"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = require("react");

var _Code = _interopRequireDefault(require("@rsuite/icons/Code"));

var _classnames = _interopRequireDefault(require("classnames"));

var _CodeEditor = _interopRequireDefault(require("./CodeEditor"));

var _Preview = _interopRequireDefault(require("./Preview"));

var _canUseDOM = _interopRequireDefault(require("./utils/canUseDOM"));

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["dependencies", "editor", "theme", "editable", "transformOptions", "code", "renderToolbar", "onChange", "beforeCompile", "compiler", "afterCompile"],
    _excluded2 = ["classPrefix", "icon", "className", "buttonClassName"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var React = require('react');

var ReactDOM = require('react-dom');

var defaultTransformOptions = {
  jsc: {
    parser: {
      syntax: 'ecmascript',
      jsx: true
    }
  }
};
var Renderer = React.forwardRef(function (props, ref) {
  var dependencies = props.dependencies,
      _props$editor = props.editor,
      editor = _props$editor === void 0 ? {} : _props$editor,
      _props$theme = props.theme,
      theme = _props$theme === void 0 ? 'light' : _props$theme,
      _props$editable = props.editable,
      isEditable = _props$editable === void 0 ? false : _props$editable,
      _props$transformOptio = props.transformOptions,
      transformOptions = _props$transformOptio === void 0 ? defaultTransformOptions : _props$transformOptio,
      code = props.code,
      renderToolbar = props.renderToolbar,
      onChange = props.onChange,
      beforeCompile = props.beforeCompile,
      compiler = props.compiler,
      afterCompile = props.afterCompile,
      rest = (0, _objectWithoutPropertiesLoose2["default"])(props, _excluded);
  var classPrefix = editor.classPrefix,
      codeIcon = editor.icon,
      editorClassName = editor.className,
      buttonClassName = editor.buttonClassName,
      editorProps = (0, _objectWithoutPropertiesLoose2["default"])(editor, _excluded2);

  var _useState = (0, _react.useState)(false),
      initialized = _useState[0],
      setInitialized = _useState[1];

  var transfrom = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    if (!_canUseDOM["default"]) {
      return;
    }

    Promise.resolve().then(function () {
      return _interopRequireWildcard(require('@swc/wasm-web'));
    }).then( /*#__PURE__*/function () {
      var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(module) {
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return module["default"]();

              case 2:
                transfrom.current = module.transformSync;
                setInitialized(true);

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
  }, []);

  var _useState2 = (0, _react.useState)(isEditable),
      editable = _useState2[0],
      setEditable = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      hasError = _useState3[0],
      setHasError = _useState3[1];

  var _useState4 = (0, _react.useState)(null),
      errorMessage = _useState4[0],
      setErrorMessage = _useState4[1];

  var _useState5 = (0, _react.useState)(null),
      compiledReactNode = _useState5[0],
      setCompiledReactNode = _useState5[1];

  var handleExpandEditor = (0, _react.useCallback)(function () {
    setEditable(!editable);
  }, [editable]);
  var handleError = (0, _react.useCallback)(function (error) {
    setHasError(true);
    setErrorMessage(error.message);
  }, []);

  var prefix = function prefix(name) {
    return classPrefix ? classPrefix + "-" + name : name;
  };

  var executeCode = (0, _react.useCallback)(function (pendCode) {
    if (pendCode === void 0) {
      pendCode = code;
    }

    if (!_canUseDOM["default"]) {
      return;
    }

    var originalRender = ReactDOM.render; // Redefine the render function, which will reset to the default value after `eval` is executed.

    ReactDOM.render = function (element) {
      setCompiledReactNode(element);
    };

    try {
      var statement = dependencies ? Object.keys(dependencies).map(function (key) {
        return "var " + key + "= dependencies." + key + ";";
      }) : [];
      var beforeCompileCode = (beforeCompile === null || beforeCompile === void 0 ? void 0 : beforeCompile(pendCode)) || pendCode;

      if (beforeCompileCode) {
        var _transfrom$current;

        var _ref2 = compiler ? compiler(beforeCompileCode) : (_transfrom$current = transfrom.current) === null || _transfrom$current === void 0 ? void 0 : _transfrom$current.call(transfrom, beforeCompileCode, transformOptions),
            compiledCode = _ref2.code;

        eval(statement.join('\n') + " " + ((afterCompile === null || afterCompile === void 0 ? void 0 : afterCompile(compiledCode)) || compiledCode));
      }
    } catch (err) {
      console.error(err);
    } finally {
      // Reset the render function to the original value.
      ReactDOM.render = originalRender;
    }
  }, [code, dependencies, beforeCompile, compiler, transformOptions, afterCompile]);
  (0, _react.useEffect)(function () {
    if (initialized) {
      executeCode(code);
    }
  }, [initialized, code, executeCode]);
  var handleCodeChange = (0, _react.useCallback)(function (code) {
    setHasError(false);
    setErrorMessage(null);
    onChange === null || onChange === void 0 ? void 0 : onChange(code);

    if (initialized) {
      executeCode(code);
    }
  }, [executeCode, initialized, onChange]);
  var codeButton = /*#__PURE__*/(0, _jsxRuntime.jsx)("button", {
    role: "switch",
    "aria-checked": editable,
    "aria-label": "Show the full source",
    className: (0, _classnames["default"])(prefix('btn'), prefix('btn-xs'), buttonClassName),
    onClick: handleExpandEditor,
    children: typeof codeIcon !== 'undefined' ? codeIcon : /*#__PURE__*/(0, _jsxRuntime.jsx)(_Code["default"], {
      className: (0, _classnames["default"])(prefix('icon'), prefix('icon-code'))
    })
  });
  var showCodeEditor = editable && code && initialized;
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", (0, _extends2["default"])({
    className: "rcv-container"
  }, rest, {
    ref: ref,
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_Preview["default"], {
      hasError: hasError,
      errorMessage: errorMessage,
      onError: handleError,
      children: compiledReactNode
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      className: "rcv-toolbar",
      children: renderToolbar ? renderToolbar(codeButton) : codeButton
    }), showCodeEditor && /*#__PURE__*/(0, _react.createElement)(_CodeEditor["default"], (0, _extends2["default"])({}, editorProps, {
      key: "jsx",
      onChange: handleCodeChange,
      className: (0, _classnames["default"])(editorClassName, 'rcv-editor'),
      editorConfig: {
        lineNumbers: true,
        theme: "base16-" + theme
      },
      code: code
    }))]
  }));
});
var _default = Renderer;
exports["default"] = _default;